var disabled = "false";
var disableSave = localStorage.getItem("SavedDisabled");
if(disableSave != null)
{
disabled = disableSave;
}

var hud = makeHud();
var wallpaper = null;

//SetUp Hud
function makeHud()
{
  var div = document.createElement("div");
  div.style.width = "30%";
  div.style.height = "auto";
  div.style.backgroundColor = "silver";
  div.style.position = "fixed";
  div.style.left = "100%";
  div.style.top = "10%";
  div.style.zIndex = 100;
  div.style.color = "black";
  div.style.textAlign = "center";
  var backURL = chrome.extension.getURL("Images/background.jpg")
  div.style.backgroundImage = "url("+backURL+")";
  div.id = "RO-Customize";
  document.body.insertBefore(div,document.body.childNodes[0]);
  nextLine("",div);
  var logo = document.createElement("IMG");
  var url = chrome.extension.getURL("Images/Logo.png")
  logo.setAttribute("src", url);
  logo.setAttribute("width", "90%");
  logo.setAttribute("height", "auto");
  div.appendChild(logo);
  nextLine("Make sure all the RGB values below are different!",div);
  nextLine("Paste an image URL below:",div);
  var newImage = makeTextBox("text","newImg","75%",div,"https://pbs.twimg.com/media/DaHdYKqV4AAh62y.png");
  nextLine("Insert RGB Values for top bar:",div);
  var newBarColor = makeTextBox("text","newBarColor","75%",div,"0,200,255");
  nextLine("Insert RGB Values for game tabs:",div);
  var newGameColor = makeTextBox("text","newGameColor","75%",div,"0,150,255");
  nextLine("Insert RGB Values for text color:",div);
  var newTextColor = makeTextBox("text","newTextColor","75%",div,"255,255,255");
  nextLine("",div);
  nextLine("",div);
  var submit = document.createElement("button");
  submit.innerHTML = "Submit";
  submit.style.backgroundColor = "dimgray";
  div.appendChild(submit);
  submit.addEventListener ("click", function() {
    div.style.left = "100%";
    if(newImage.value != ""){curImage = newImage.value}
    if(newBarColor.value != ""){curBarColor = newBarColor.value}
    if(newGameColor.value != ""){curGameColor = newGameColor.value}
    if(newTextColor.value !=""){curTextColor = newTextColor.value}
    localStorage.setItem("SavedBackground",curImage);
    localStorage.setItem("SavedBarColor",curBarColor);
    localStorage.setItem("SavedGameColor",curGameColor);
    localStorage.setItem("SavedTextColor",curTextColor);
    createNewBackground();
    if(curImage != "" && wallpaper != null)
    {
      wallpaper.setAttribute("src",curImage)
    }
  });
  nextLine("",div);
  var cancel = document.createElement("button");
  cancel.innerHTML = "Cancel";
  cancel.style.backgroundColor = "dimgray";
  div.appendChild(cancel);
  cancel.addEventListener ("click", function() {
    div.style.left = "100%";
  });
  nextLine("",div); 
  var t = document.createTextNode("Disabled:");
  div.appendChild(t);  
  var disableBut = makeTextBox("checkbox","disable","5%",div);
  if(disabled == "false")
  {
  disableBut.checked = false;  
  }
  else
  {
    disableBut.checked = true;
  }

  disableBut.addEventListener ("click", function() {
	disabled = disableBut.checked;
        localStorage.setItem("SavedDisabled",disabled);
        location.reload();
  });
 return div
}

function makeTextBox(type,name,width,div,defaultVal)
{
  var x = document.createElement("INPUT");
  x.setAttribute("type", type);
  x.setAttribute("name", name);
  x.setAttribute("placeholder", defaultVal);
  x.class = name
  x.style.width = width;
  div.appendChild(x);
return x
}

function nextLine(text,div)
{
  var b = document.createElement("BR");
  div.appendChild(b);
  var b = document.createElement("BR");
  div.appendChild(b);
  var t = document.createTextNode(text);
  div.appendChild(t);
}
//End Setup Hud Functions

if(disabled == "false")
{
var curImage = null
var curBarColor = null
var curGameColor = null
var curTextColor = null
var savedImage= localStorage.getItem("SavedBackground");
var savedBarColor= localStorage.getItem("SavedBarColor");
var savedGameColor= localStorage.getItem("SavedGameColor");
var savedTextColor = localStorage.getItem("SavedTextColor");

if (savedImage != null)
{
curImage = savedImage;
}


if (savedBarColor != null)
{
curBarColor = savedBarColor;
}


if (savedGameColor != null)
{
curGameColor = savedGameColor;
}


if (savedTextColor != null)
{
curTextColor = savedTextColor;
}



//Where the Magic Begins
createNewWallPaper();
createNewBackground();
changeColors();
//where the magic ends

function makeInput(type,name,width)
{
  var x = document.createElement("input");
  x.setAttribute("type", type);
  x.setAttribute("name", name);
  x.style.width = width;
  x.style.height = "auto";
  return x;
}

function createNewWallPaper()
{
if(curImage != null)
{
wallpaper = makeImg();
var mainPage = document.getElementsByClassName("container-main");
if (mainPage[0] != null)
{
mainPage[0].insertBefore(wallpaper,mainPage[0].childNodes[0]);
}
}
}

function createNewBackground()
{
var pagecontent = document.getElementsByClassName("content");
if (pagecontent[0] != null)
{
pagecontent[0].style.backgroundColor = "transparent";
}

var studioPage = document.getElementsByClassName("nav-content logged-in");
if(studioPage[0] != null)
{
studioPage[0].insertBefore(wallpaper,studioPage[0].childNodes[0]);
}

var bodyWidth= document.getElementsByClassName("body-width");
if(bodyWidth[0] != null)
{
bodyWidth[0].style.backgroundColor = "transparent";
}

var playerPage = document.querySelectorAll('div[class*="section-content"],[class*="rbx-tab"],div[class*="profile-avatar-mask"],div[class*="item-container-right"],ul[class*="menu"]');
if(playerPage[0] != null)
{
for (var i = 0; i < playerPage.length; i++) 
{
playerPage[i].style.backgroundColor = "rgb("+curGameColor+")";
}
}
	
var playerPage = document.querySelectorAll('div[class*="col-sm-6 section-content profile-avatar-left"],div[class*="item-container-left"]');
if(playerPage[0] != null)
{
for (var i = 0; i < playerPage.length; i++)
{
playerPage[i].style.backgroundColor = "rgb("+curBarColor+")";
}
}

var gamePageLayers = document.querySelectorAll('div[class~="bg-gray-4"],div[class*="tab-content rbx-tab-content"],div[class*="rbx-tabs-horizontal"],[class*="col-xs-12 rbx-tabs-vertical assets-explorer-main-content ng-scope"]');
if(gamePageLayers[0] != null)
{
for (var i = 0; i < gamePageLayers.length; i++) 
{
gamePageLayers[i].style.backgroundColor = "transparent";
}
}
}


function makeImg()
{
  var x = document.createElement("IMG");
  x.setAttribute("src", curImage);
  x.setAttribute("width", "100%");
  x.setAttribute("height", "auto");
  x.style.position = "fixed";
  x.style.zIndex = -1;
  return x;
}

setInterval(changeColors,100);

function changeColors()
{

 if(curBarColor !=null)
 {
  var colorSections= document.querySelectorAll('[class*="container-f"],[class*="dialog-container"],[class*="dialogs-minimize-container"],[class*="dropdown-menu"],[class*="game-item-container"],[class*="dialog-triangle"],[class*="rbx-left-col"],[class*="dialog-input"],div[class*="unread"],[class*="notification-stream-header ng-scope"],[class*="notification-blue"]');
  if(colorSections[0] != null)
  {
   for (var i = 0; i < colorSections.length; i++) 
   {
    colorSections[i].style.backgroundColor = "rgb("+curBarColor+")";
   }
  }
 }


if(curTextColor != null)
{
var pagecontent = document.querySelectorAll('div.content,[class^="font"],[class*="text"],[class*="message-piece"],[class*="game-card-name"],[class*="link"],[class^="item-card-thumb"],[class^="btn-primary"],[class*="ng-binding"],[class*="notification"]');
 if (pagecontent[0] != null)
 {
   for (var i = 0; i < pagecontent.length; i++) 
   {
    pagecontent[i].style.color = "rgb("+curTextColor+")";
   }
 }
}

if(curTextColor != null && curBarColor != null)
{	
  var colorSections= document.querySelectorAll('[class^="chat"],[class*="indicated-message-bubble"]');
  if(colorSections[0] != null)
  {
   for (var i = 0; i < colorSections.length; i++) 
   {
    colorSections[i].style.color = "rgb("+curTextColor+")";
    colorSections[i].style.backgroundColor = "rgb("+curBarColor+")";
   }
  }
}


if(curGameColor != null)
{
  var colorSections= document.querySelectorAll('[class*="game-card-container"],[class*="scrollbar"],[class*="input-field"],[class^="item-card"],[class*="ng-scope read"],[class$="roblox-message-row ng-scope"],[class$="border-top message-news sub-divider-bottom messageDivider ng-scope"],[class*="avatar-card-container"],[class*="avatar-card-btns"],[class*="border-bottom notification-stream-item ng-scope unInteracted"],[class$="mCSB_container"],[class*="notification-red"]');
  if(colorSections[0] != null)
  {
   for (var i = 0; i < colorSections.length; i++) 
   {
    colorSections[i].style.backgroundColor = "rgb("+curGameColor+")";
   }
  }
}

  var colorSections= document.querySelectorAll('[class*="mCSB_scrollTools mCSB_2_scrollbar mCS-light mCSB_scrollTools_vertical"],[class*="mCSB_scrollTools mCSB_1_scrollbar mCS-light mCSB_scrollTools_vertical"],[class$="chat-friend-message ng-scope read"]');
  if(colorSections[0] != null)
  {
   for (var i = 0; i < colorSections.length; i++) 
   {
    colorSections[i].style.backgroundColor = "transparent";
   }
  } 
}
}
// content.js
chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    hud.style.left = "35%";
  }
);